brain_two/urls.py
from django.contrib import admin
from django.shortcuts import redirect
from django.urls import path, include, reverse_lazy
from django.views.generic.base import RedirectView


urlpatterns = [
    path('admin/', admin.site.urls),
    path('todos/', include('todos.urls')),
    path("", RedirectView.as_view(url=reverse_lazy("todo_list")), name="home"),
]

todos/urls.py
from django.urls import path

from todos.views import (
    TodoItemCreateView,
    TodoListCreateView,
    TodoListDetailView,
    TodoListListView,
    TodoListDeleteView,
    TodoListUpdateView,
)


urlpatterns = [
    path("", TodoListListView.as_view(), name="todo_list"),
    path("<int:pk>/", TodoListDetailView.as_view(), name="todo_detail"),
    path("items/create/", TodoItemCreateView.as_view(), name="todoitem_new"),
    path("create/", TodoListCreateView.as_view(), name="todolist_new"),
    path("<int:pk>/delete/", TodoListDeleteView.as_view(), name="todo_delete"),
    path("<int:pk>/edit/", TodoListUpdateView.as_view(), name = "todo_edit"),
]

todos/models.py
from email.policy import default
from xmlrpc.client import DateTime
from django.db import models
from django.forms import DateTimeField

# Create your models here.

class TodoList(models.Model):
    name = models.CharField(max_length=100)
    created_on = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return self.name

class TodoItem(models.Model):
    task = models.CharField(max_length=100)
    due_date = models.DateTimeField(null=True, blank=True)
    is_completed = models.BooleanField(default=False)
    list = models.ForeignKey(
        "TodoList",
        related_name="items",
        on_delete=models.CASCADE
    )
    def __str__(self):
        return self.task

todos/views.py
from pyexpat import model
from re import template
from django.shortcuts import render, redirect
from django.urls import reverse_lazy
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, DeleteView, UpdateView
from django.views.generic.list import ListView
from todos.models import TodoList, TodoItem


# Create your views here.

class TodoListListView(ListView):
    model = TodoList
    template_name = "todos/list.html"


class TodoListDetailView(DetailView):
    model = TodoList
    template_name = "todos/detail.html"


class TodoListCreateView(CreateView):
    model = TodoList
    template_name = "todos/create.html"
    fields = ["name"]

    def form_valid(self, form):
        owner = form.save(commit=False)
        owner.user = self.request.user
        owner.save()
        return redirect("todo_list")


class TodoItemCreateView(CreateView):
    model = TodoItem
    template_name = "todos/create.html"
    fields = ["task", "due_date", "list"]
    
    def form_valid(self, form):
        owner = form.save(commit=False)
        owner.user = self.request.user
        owner.save()
        return redirect("todo_list")
 

class TodoListDeleteView(DeleteView):
    model = TodoList
    template_name = "todos/delete.html"


class TodoListUpdateView(UpdateView):
    model = TodoList
    template_name = "todos/edit.html"
    fields = ["name"]
    
    def form_valid(self, form):
        owner = form.save(commit=False)
        owner.user = self.request.user
        owner.save()
        return redirect("todo_list")

todos/templates/base.html
{% load static %}

<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Django One Tap</title>
    <link rel="stylesheet" href="{% static 'css/app.css' %}" />
  </head>
  <body>
    <header>
        <nav>
          <ul>
            <li>
              <a href="{% url 'todolist_new' %}">Create To Do List</a>
            </li>
            <li>
              <a href="{% url 'todoitem_new' %}">Create To Do Items</a>
            </li>
          </ul>
        </nav>
    </header>
    <div></div>
    {% block content %} {% endblock content %}
  </body>
</html>

todos/templates/todos/create.html
{% extends 'base.html' %} 


{% block content %}
<main class="todos-form">
  <form method="post">
    {% csrf_token %} {{ form.as_p }}
    <div class="control">
      <button class="button">Create</button>
    </div>
  </form>
</main>
{% endblock content %}

todos/templates/todos/delete.html
{% extends 'base.html' %}

{% block content %}
  <main>
    <div class="delete-form">
      <form method="post">
        {% csrf_token %}
        {{ form.as_p }}
        <div>
          <button class="button">Delete</button>
        </div>
      </form>
    </div>
  </main>
{% endblock content %}

todos/templates/todos/detail.html
{% extends 'base.html' %}

{% block content %}

<main>
    <h2>To Do Details</h2>
    <table>
      <thead>
        <tr>
          <th>Details</th>
        </tr>
      </thead>
      <tbody>
        {% for item in items_list %}
        <tr>
          <td>{{ item.task }}</td>
          <td> <a href="{% url 'todo_edit' items.id %}">Edit</a> </td>
          {% endfor %}
        </tr>
      </tbody>
    </table>
  </main>

  {% endblock content %}

todos/templates/todos/edit.html
{% extends 'base.html' %}

{% block content %}
  <main class="todo-form">
    <form method="post">
      {% csrf_token %}
      {{ form.as_p }}
      <div class="control">
        <button class="button">Update</button>
      </div>
    </form>
  </main>
{% endblock content %}

todos/templates/todos/list.html
{% extends 'base.html' %}

{% block content %}

<main>
    <h2>To Do List</h2>
    <table>
      <thead>
        <tr>
          <th>Lists</th>
        </tr>
      </thead>
      <tbody>
        {% for task in todolist_list %}
        <tr>
          <td>{{ task.name }}</td>
          <td> <a href="{% url 'todo_detail' task.id %}">Details</a> </td>
          <td> <a href="{% url 'todo_delete' task.id %}">Delete</a> </td>
          <td> <a href="{% url 'todo_edit' task.id %}">Edit</a> </td>
          {% endfor %}
        </tr>
      </tbody>
    </table>
  </main>

  {% endblock content %}